package eval

import (
	"git.urbach.dev/cli/q/src/types"
)

// Value abstracts all data storage types like immediates, registers and memory.
type Value interface {
	String() string
	Type() types.Type
}

// IsAlive returns true if the register value is still alive.
func (v *Register) IsAlive() bool {
	return v.Alive > 0
}

// Use reduces the lifetime counter by one.
func (v *Register) Use() {
	if v.Alive == 0 {
		panic("incorrect number of value use calls")
	}

	v.Alive--
}
